<template>
  <section class="slider">
    <svg class="lupa" @click="openImgSlider" width="90" height="90" viewBox="0 0 90 90" fill="none"
      xmlns="http://www.w3.org/2000/svg">
      <path
        d="M37.3062 41.1328C37.3049 39.0595 37.8612 37.0239 38.9168 35.2394C39.9725 33.4549 41.4886 31.9872 43.3063 30.9899C45.124 29.9926 47.1765 29.5025 49.2488 29.5709C51.321 29.6393 53.3367 30.2637 55.0847 31.3787C55.3712 31.5545 55.6542 31.7602 55.9214 31.9676C56.1165 32.117 56.3081 32.2752 56.4944 32.4404C56.6808 32.6057 56.8653 32.7762 57.0429 32.9537C57.2248 33.1542 57.3226 33.417 57.3161 33.6877C57.3096 33.9583 57.1993 34.2161 57.0079 34.4077C56.8166 34.5992 56.559 34.7099 56.2883 34.7167C56.0177 34.7235 55.7547 34.626 55.554 34.4443C55.4063 34.2984 55.2552 34.1578 55.1022 34.0225C54.9493 33.8871 54.7946 33.7605 54.6347 33.6375C54.4149 33.4617 54.1847 33.3053 53.9491 33.1559C52.2793 32.0922 50.3176 31.5795 48.3409 31.6902C46.3641 31.8008 44.472 32.5292 42.9312 33.7726C41.3905 35.016 40.279 36.7116 39.7533 38.6205C39.2277 40.5293 39.3146 42.5549 40.0016 44.4117C40.6886 46.2686 41.9412 47.8629 43.5826 48.9699C45.2241 50.0769 47.1716 50.6407 49.1506 50.5818C51.1296 50.5229 53.0402 49.8442 54.6129 48.6416C56.1856 47.4389 57.3411 45.7729 57.9165 43.8785C58.0155 43.5485 58.0971 43.2134 58.1608 42.8748C58.2312 42.4983 58.2787 42.118 58.3032 41.7357C58.3226 41.4563 58.3278 41.1732 58.3208 40.8938C58.3138 40.6143 58.2962 40.3559 58.2663 40.0922C58.2236 39.6975 58.1561 39.3059 58.0642 38.9197C58.0321 38.7849 58.0269 38.6451 58.0488 38.5083C58.0707 38.3715 58.1194 38.2403 58.1921 38.1223C58.3388 37.8839 58.5741 37.7136 58.8464 37.6488C59.1187 37.584 59.4055 37.63 59.6438 37.7767C59.8822 37.9234 60.0525 38.1588 60.1173 38.4311C60.2297 38.9024 60.3125 39.3803 60.3651 39.8619C60.4003 40.1836 60.4214 40.5141 60.4302 40.841C60.439 41.168 60.4302 41.5301 60.4108 41.8711C60.3796 42.3382 60.3209 42.8031 60.2351 43.2633C59.7054 46.0967 58.1366 48.6301 55.8361 50.3669C53.5356 52.1037 50.6694 52.9186 47.7993 52.6519C44.9292 52.3853 42.2621 51.0562 40.321 48.9253C38.3799 46.7944 37.3047 44.0153 37.3062 41.1328Z"
        fill="#6B6B6B" fill-opacity="0.5" />
      <path
        d="M29.5708 59.3684C29.5714 59.2296 29.5993 59.0924 29.653 58.9645C29.7067 58.8366 29.7851 58.7206 29.8837 58.623L40.2161 48.2924C40.4168 48.1107 40.6798 48.0132 40.9504 48.02C41.2211 48.0268 41.4787 48.1375 41.67 48.329C41.8614 48.5206 41.9717 48.7784 41.9782 49.049C41.9847 49.3197 41.8869 49.5825 41.705 49.783L31.369 60.1172C31.2215 60.2639 31.0338 60.3637 30.8296 60.4039C30.6254 60.4442 30.4139 60.4232 30.2217 60.3435C30.0294 60.2638 29.865 60.1291 29.7492 59.9562C29.6334 59.7833 29.5713 59.58 29.5708 59.3719V59.3684Z"
        fill="#6B6B6B" fill-opacity="0.5" />
      <path
        d="M47.8125 44.7029V37.5504C47.8125 37.2707 47.9236 37.0024 48.1214 36.8046C48.3192 36.6068 48.5875 36.4957 48.8672 36.4957C49.1469 36.4957 49.4152 36.6068 49.613 36.8046C49.8108 37.0024 49.9219 37.2707 49.9219 37.5504V44.7029C49.9219 44.9826 49.8108 45.2509 49.613 45.4487C49.4152 45.6465 49.1469 45.7576 48.8672 45.7576C48.5875 45.7576 48.3192 45.6465 48.1214 45.4487C47.9236 45.2509 47.8125 44.9826 47.8125 44.7029Z"
        fill="#6B6B6B" fill-opacity="0.5" />
      <path
        d="M44.2359 41.1328C44.2359 40.8531 44.3471 40.5848 44.5448 40.387C44.7426 40.1892 45.0109 40.0781 45.2906 40.0781H52.4414C52.7211 40.0781 52.9894 40.1892 53.1872 40.387C53.385 40.5848 53.4961 40.8531 53.4961 41.1328C53.4961 41.4125 53.385 41.6808 53.1872 41.8786C52.9894 42.0764 52.7211 42.1875 52.4414 42.1875H45.2889C45.0094 42.187 44.7416 42.0757 44.5442 41.878C44.3468 41.6802 44.2359 41.4122 44.2359 41.1328Z"
        fill="#6B6B6B" fill-opacity="0.5" />
    </svg>

    <div class="slider__flex">
      <div class="slider__col">
        <div class="slider__prev" @click="slidePrev" v-if="images.length >= 4">
          <svg width="23" height="12" viewBox="0 0 23 12" fill="none" xmlns="http://www.w3.org/2000/svg">
            <path d="M11.5 0L22.3253 11.25L0.674683 11.25L11.5 0Z" fill="#383838" />
          </svg>

        </div>
        <div class="slider__thumbs">
          <div class="swiper-container">
            <div class="swiper-wrapper">
              <div class="swiper-slide" v-for="(img, index) in sortImage" :key="index">
                <div class="slider__image imgCol">
                  <img :src="img.image" alt="" @click="selectImage(index)"
                    :style="urlImg === img.image ? { 'opacity': '1' } : { 'opacity': '0.5' }" />
                </div>
              </div>
            </div>
          </div>
        </div>
        <div class="slider__next" @click="slideNext" v-if="images.length >= 4">
          <svg width="23" height="12" viewBox="0 0 23 12" fill="none" xmlns="http://www.w3.org/2000/svg">
            <path d="M11.5 12L0.674683 0.75H22.3253L11.5 12Z" fill="#383838" />
          </svg>

        </div>
      </div>
      <div class="slider__images">
        <div class="swiper-container">
          <div class="swiper-wrapper">
            <div class="swiper-slide" v-for="(img, index) in sortImage" :key="index">
              <div class="slider__image">
                <img :src="img.image" alt="" />
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </section>
</template>

<script>
import Swiper from "swiper";
export default {
  props: {
    images: Array
  },
  computed: {
    sortImage() {
      return [...this.images].sort((a, b) => {
        // Если a.general === true, поместить a перед b
        if (a.general === true && b.general !== true) {
          return -1;
        }
        // Если b.general === true, поместить b перед a
        if (b.general === true && a.general !== true) {
          return 1;
        }
        // Если оба элемента имеют одинаковое значение general, сохранить исходный порядок
        return 0;
      });
    }

  },
  data() {
    return {
      sliderThumbs: null,
      sliderImages: null,
      urlImg: ''
    };
  },
  methods: {

    slidePrev() {
      this.sliderThumbs.slidePrev();
    },
    slideNext() {
      this.sliderThumbs.slideNext();
    },
    selectImage(index) {
      this.sliderImages.slideTo(index);
    },
    openImgSlider() {
      if (this.urlImg === '') {
        window.open(this.images[0].image, '_blank')
      } else {
        window.open(this.urlImg, '_blank')
      }
    },

  },

  async mounted() {


    this.sliderThumbs = new Swiper(".slider__thumbs .swiper-container", {
      direction: "vertical",
      slidesPerView: 3,
      spaceBetween: 40,
      navigation: {
        nextEl: ".slider__next",
        prevEl: ".slider__prev",
      },
      freeMode: true,
      breakpoints: {
        0: {
          direction: "horizontal",
        },
        768: {
          direction: "vertical",
        },

      },
    });

    this.sliderImages = new Swiper(".slider__images .swiper-container", {
      direction: "vertical",
      slidesPerView: 1,
      spaceBetween: 40,
      mousewheel: true,
      navigation: {
        nextEl: ".slider__next",
        prevEl: ".slider__prev",
      },
      grabCursor: true,
      thumbs: {
        swiper: this.sliderThumbs,
      },
      breakpoints: {
        0: {
          direction: "horizontal",
        },
        768: {
          direction: "vertical",
        },
      },
      on: {
        slideChange: () => {
          const currentIndex = this.sliderImages.realIndex;
          const currentImageUrl = this.sortImage[currentIndex].image;
          this.urlImg = currentImageUrl;
        },

      },
    });
  }
};
</script>

<style>
.slider {
  height: calc(100vh - 80px);
  position: fixed;
  top: 40px;
  left: 80px;
  width: calc(50% - 120px);
}

.slider .lupa {
  position: absolute;
  right: -15px;
  top: 25px;
  z-index: 455;
  cursor: pointer;
}

.slider .swiper-container {
  overflow: hidden;
  max-width: 100%;
  width: 100%;
  height: 100%;
}

.slider__flex {
  display: flex;
  justify-content: center;
  align-items: center;
  height: 100%;
  position: relative;
}

.slider__col {
  display: flex;
  flex-direction: column;
  justify-content: center;
  margin-right: 40px;
  max-width: 168px;
  height: 78.3vh;
}

.swiper-slide img {
  width: 100%;
  height: 100%;

}

.slider__prev,
.slider__next {
  cursor: pointer;
  text-align: center;
  display: flex;
  align-items: center;
  justify-content: center;
  -webkit-user-select: none;
  -moz-user-select: none;
  -ms-user-select: none;
  user-select: none;
  z-index: 6px;
  margin: 3.3vh;
}


.slider__thumbs {
  height: 61.8vh;
}

.slider__thumbs .slider__image {
  transition: 0.25s;
  filter: none;
}

.slider__thumbs .slider__image:hover {
  cursor: pointer;
}

.slider__images {
  flex-grow: 1;
  height: calc(100% - 80px);
}

.slider__images .slider__image img {
  transition: 3s;
  border-radius: 0px;
}

.slider__image {
  width: 100%;
  height: 100%;
  border-radius: 0px;
  overflow: hidden;
}

.slider__image img {
  display: block;
  -o-object-fit: cover;
  object-fit: cover;

}

.imgCol {
  flex-grow: 1;
  height: 17.6vh;
  width: 17.6vh;
}
</style>